import 'gun/sea';
import 'gun/lib/then.js';
import { IGunChainReference } from 'gun/types/chain';
export interface StackOptions {
    peers?: string[];
    app: string;
}
export interface StackContext {
    gun: IGunChainReference<any, any, any>;
    app: string;
}
export interface Node<T = any> {
    data?: T;
    on: (listener: (data: T) => void) => void;
    path: string;
}
export interface Stack {
    node: <T = any>(path: string, put?: T) => Promise<Node<T>>;
    context: StackContext;
}
export declare const getRootNode: (context: StackContext) => Promise<(<T = any>(path: string, put?: T | undefined) => Promise<Node<T>>)>;
export declare const createStack: ({ peers, app }: StackOptions) => Promise<Stack>;
